#ifndef SIPL_H
#define SIPL_H
/*
 * SIPL C Interface Header
 *
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>



struct img{
    int row;
    int col;
    unsigned char *r;
    unsigned char *g;
    unsigned char *b; 
} ;


struct matrix{
	int row;
	int col;
	double *data;
} ;

struct  pixel {
	unsigned char r;
    unsigned char g;
    unsigned char b; 	
};

struct matrix* initMatrix(double * mat_data_ptr, int m, int n);
struct img*  imgread(const char*filename);
int imgwrite(struct img *mat, int fmt, const char *filename);
int changeGrey(struct img* image);
int rotateImage(struct img* image);
int flipImage(struct img* image, int n);
struct matrix* kernel(const char* str);
struct img* convImg(struct img *image, struct matrix *mat);
struct img* elementMult(struct img *img1, double num );
struct img* elementSub(struct img *img1, int num );
struct img* elementAdd(struct img *img1, int num );
struct img* imgAdd(struct img *img1, struct img *img2 );
struct img* imgCopy(struct img * img1);


#endif
